--- asterisk-1.6.2.6.orig/channels/chan_sip.c	2010-03-22 15:52:13.000000000 -0400
+++ asterisk-1.6.2.6/channels/chan_sip.c	2010-03-22 16:12:57.000000000 -0400
@@ -22265,8 +22267,13 @@
 			AST_EVENT_IE_MAILBOX, AST_EVENT_IE_PLTYPE_STR, mailbox->mailbox,
 			AST_EVENT_IE_CONTEXT, AST_EVENT_IE_PLTYPE_STR, S_OR(mailbox->context, "default"),
 			AST_EVENT_IE_END);
-		if (!event)
-			continue;
+		if (!event) {
+			/* If we don't have a cached event for one of the
+			 * mailboxes, we need to abort so the caller can
+			 * check for messages the old-fashioned way. */
+			*new = *old = 0;
+			break;
+		}
 		*new += ast_event_get_ie_uint(event, AST_EVENT_IE_NEWMSGS);
 		*old += ast_event_get_ie_uint(event, AST_EVENT_IE_OLDMSGS);
 		ast_event_destroy(event);
@@ -22289,10 +22296,7 @@
 	if (!peer->addr.sin_addr.s_addr && !peer->defaddr.sin_addr.s_addr) 
 		return 0;
 
-	if (event) {
-		newmsgs = ast_event_get_ie_uint(event, AST_EVENT_IE_NEWMSGS);
-		oldmsgs = ast_event_get_ie_uint(event, AST_EVENT_IE_OLDMSGS);
-	} else if (!get_cached_mwi(peer, &newmsgs, &oldmsgs)) {
+	if (!get_cached_mwi(peer, &newmsgs, &oldmsgs)) {
 		/* got it!  Don't keep looking. */
 	} else if (cache_only) {
 		return 0;
